unit GUIControl;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, QComCtrls, ExtCtrls, DBCtrls, jpeg, Menus,
  IniFiles, ComCtrls, HelpTools, DateUtils;

type TGUIControl=class(TComponent)
private


public
  SurveillanceUnitCount: Integer;
  constructor Create(Aowner: TComponent); override;
  function SearchDevicesToRealTimeValues(const FileName: String): TStrings;
  function SearchDeviceTypes (const FileName: String) : TStrings;
  function ReadDeviceDataFromIni(const FileName: String): TStrings;
  function IntValuesToBooleanString(value: String): String;
  function ReadIniFileNames(): TStrings;
  function RemoveIniFromFileName(filename: String): String;
  function ReadAlarmTargetIni (i: Integer): TStrings;
  function ReadPrioritiesIni (i: Integer): TStrings;
  function GetCount(const Path: String; key: String='NumberOf'): Integer;
  function ReadOneDevicesDataFromIni(const FileName: String; const devicename: String): TStrings;
  function ReadAlarmLimitsFromIniFile(const FileName: String; const DeviceName: String): TStrings;
  function SearchDevice(const FileName: String; const DeviceName: String): String;
  procedure WriteAlarmtargetIni(const Targets: TStrings; const NumberOfTargets: String;
                                const sectionindex: Integer);
  procedure WritePriorityLimitsToIni(const FileName: String; const DeviceName: String;
                                    const Prioritydata: TStrings; const row: Integer);
  procedure WriteDeviceData(const FileName: String; const DeviceName: String; const Data: TStrings);

  procedure WritePriority(const PriorityData: TStrings; const NumberOfPriorities: String; const sectionindex: Integer);


  
  procedure GetAllDeviceLogFiles(const unitname: String);

  procedure DeleteAllFiles(const path: String);
  function  ReadCommunicationSettingsIniFile(): TStrings;
  function  SearchDeviceType(const FileName: String; const deviceName: String): String;
  function  SensorValue(const FileName: String): String;
  function  SearchLatestAlarms(): TStrings;
  function  AllRealTimeSensorValues(const IniFileName: String): TStrings;
  function  ReadDatesFromLog(const FileName: String): TStrings;
  function  EraseDate(line: String): String;
  function  StringExists(line: String; Strings: TStrings): Boolean;
  function  GetTimesFromTemperatureLog(const date: String; const FileName: String): TStrings;
  function  CalculateTheAverageTemperaturePerHour(): TStrings;
  function  GetFileNames(const path: String): TStrings;
  end;

implementation
var Inifile: TIniFile;

constructor TGUIControl.Create(Aowner: TComponent);
begin
inherited;
  SurveillanceUnitCount:=0;
 // DeleteAllFiles('.\gestapo\config\');
end;

function TGUIControl.RemoveIniFromFileName(filename: String): String;
var stringlength: integer;
begin
   stringlength:=length(filename);
   delete(filename,stringlength-3,5);
   result:=filename;
end;

function TGUIControl.IntValuesToBooleanString(value: String): String;
begin
  if value='0' then result:='false'
  else result:='true';
end;

function TGUIControl.ReadIniFileNames(): TStrings;
var   FoundFile: TSearchRec;
      FileAttr: Integer;
      FileNames: TStrings;
      FileName: String;

begin
  FileNames:=TStringList.Create;
  FileAttr:=faAnyFile;
  FindFirst('.\gestapo\config\*',FileAttr,FoundFile);
  FindNext(FoundFile);
  while FindNext(FoundFile)=0 do
   begin
   FileName:=FoundFile.Name;
   If FileName='alarmunit.ini' then continue;
   FileNames.Add(FoundFile.Name);
   SurveillanceUnitCount:=SurveillanceUnitCount+1;
   end;
   result:=FileNames;
end;

function TGUIControl.GetCount(const Path: String; key: String='NumberOf'): Integer;
var FileIni: TIniFile;
begin
   result:=0;
   FileIni:=TIniFile.Create(Path);
   if FileExists(Path) then
     result:=FileIni.ReadInteger('general',key,0)
   else exception.Create('File Not Found');
   FileIni.free();
end;

function TGUIControl.ReadPrioritiesIni(i: Integer): TStrings;
var PrioritiesData: TStrings;
    section: String;
begin
  PrioritiesData:=TStringLIst.Create;
  section:='Priority'+IntToStr(i);
  if FileExists('.\gestapo\config\alarmunit.ini') then
    begin
      IniFile:=TIniFile.Create('.\gestapo\config\alarmunit.ini');
      PrioritiesData.Add(IniFile.ReadString(section,'PriorityValue','0'));
      PrioritiesData.Add(IniFile.ReadString(section,'UseSMS','0'));
      PrioritiesData.Add(iniFile.ReadString(section,'UseEmail','0'));
      PrioritiesData.Add(IniFile.ReadString(section,'UseLocalDevice','0'));
      PrioritiesData.Add(IniFile.ReadString(section,'RepeatInterval','0'));
      PrioritiesData.Add(IniFile.ReadString(section,'Target','0'));
    end
  else exception.Create('File Not Found');
  IniFile.Free;
  result:=PrioritiesData;
end;

function TGUIControl.ReadAlarmTargetIni(i: Integer): TStrings;
var section: String;
    AlarmData: TStrings;
begin
    alarmdata:=TStringList.Create;
    section:='Target'+IntToStr(i+1);
    if FileExists('.\gestapo\config\alarmunit.ini') then
    begin
    IniFile:=TIniFIle.Create('.\gestapo\config\alarmunit.ini');
    alarmdata.add(IniFile.ReadString(section,'Target','0'));
    alarmdata.Add(IniFile.ReadString(section,'targetname',''));
    alarmdata.add(IniFile.ReadString(section,'Email',''));
    alarmdata.add(IniFile.ReadString(section,'GSM',''));
    end
    else exception.Create('File Not found');
    result:=alarmdata;
    IniFile.free;
end;

procedure TGUIControl.WriteAlarmTargetIni(const Targets: TStrings; const NumberOfTargets: String; const sectionindex: Integer);

begin
   if Targets.Strings[0]='' then exit;
   IniFile:=TIniFile.Create('.\gestapo\config\alarmunit.Ini');
   IniFile.WriteString('general','NumberOf',NumberOfTargets);

   IniFile.WriteString('Target'+IntToStr(sectionindex),'Target',Targets.Strings[0]);
   IniFile.WriteString('Target'+IntToStr(sectionindex),'TargetName',Targets.Strings[1]);
   IniFile.WriteString('Target'+IntToStr(sectionindex),'Email',Targets.Strings[2]);
   IniFile.WriteString('Target'+IntToStr(sectionindex),'GSM',Targets.Strings[3]);
   IniFile.Free;

end;

function TGUIControl.ReadDeviceDataFromIni(const FileName: String): TStrings;
var devicedata: TStrings;
    section: String;
    i: Integer;
begin
  devicedata:=TStringList.Create();
  IniFile:=TInifile.create('.\gestapo\config\'+FileName);

  for i:=0 to GetCount('.\gestapo\config\'+FileName)-1 do
  begin
      section:='device'+IntToStr(i);
      devicedata.Add(IniFile.ReadString(section,'sensorID','0'));
      devicedata.Add(IniFile.ReadString(section,'DeviceName',''));
      devicedata.Add(IniFile.ReadString(section,'Type',''));
      devicedata.Add(IniFile.ReadString(section,'CaptionInterval','0'));
      devicedata.Add(IniFile.ReadString(section,'AlarmMode','0'));

  end;
  IniFile.free;
  result:=devicedata;
end;

function TGUIControl.ReadOneDevicesDataFromIni(const FileName: String; const DeviceName: String): TStrings;
var section: String;
    i: Integer;
    name: String;
    device: TStrings;
begin
   device:=TStringList.Create;
   IniFile:=TIniFile.Create('.\gestapo\config\'+FileName);
   for i:=0 to GetCount('.\gestapo\config\'+FileName)-1 do
   begin
   section:='Device'+IntToStr(i);
   name:=IniFile.ReadString(section,'DeviceName','');
   If name=DeviceName then
     begin
     device.Add(IniFile.ReadString(section,'sensorID','0'));
     device.Add(IniFile.ReadString(section,'DeviceName',''));
     device.Add(IniFile.ReadString(section,'Type',''));
     device.Add(IniFile.ReadString(section,'DeviceName',''));
     device.Add(IniFile.ReadString(section,'CaptionInterval','0'));
     device.Add(IniFile.ReadString(section,'AlarmModes','0'));
    result:= device; exit;
    end;
   end;
  result:=device;
  IniFile.free;
end;

function TGUIControl.SearchDevice(const FileName: String; const DeviceName: String): String;
var i: Integer;
   FileIni: TInifile;
   comparename: String;
begin
   result:='';
   FileIni:=TInifile.Create('.\gestapo\config\'+Filename);
   for i:=0 to GetCount('.\gestapo\config\'+FileName)-1 do
   begin
     comparename:=FileIni.ReadString('device'+IntTOStr(i),'DeviceName','');
        if DeviceName=comparename then result:='device'+IntToStr(i);
   end;
   FileIni.Free;
end;

function TGUICOntrol.ReadAlarmLimitsFromIniFile(const FileName: String; const DeviceName: String): TStrings;
var AlarmLimits: TStrings;
    i: Integer;
    name: String;
begin
  IniFile:=TIniFile.Create('.\gestapo\config\'+FileName);
  AlarmLimits:=TStringList.Create;
  name:=SearchDevice(FileName,DeviceName);
  for i:=0 to StrToInt(IniFile.ReadString(name,'AlarmModes','0'))-1 do
  begin
    AlarmLimits.Add(IniFile.ReadString(deviceName+'Limits'+IntToStr(i),'priority','0'));
    AlarmLimits.Add(IniFile.ReadString(deviceName+'Limits'+IntToStr(i),'Start','0:00'));
    AlarmLimits.Add(IniFile.ReadString(deviceName+'Limits'+IntToStr(i),'End','0:00'));
    AlarmLimits.Add(IniFile.ReadString(deviceName+'Limits'+IntToStr(i),'Min','0'));
    AlarmLimits.Add(IniFile.ReadString(deviceName+'Limits'+IntToStr(i),'Max','0'));
  end;
  IniFile.free;
  result:=alarmlimits;
end;

procedure TGUIControl.WritePriorityLimitsToIni(const FileName: String; const DeviceName: String; const Prioritydata: TStrings; const row: Integer);
begin
  IniFile:=TInifile.Create('.\gestapo\config\'+FileName);
  if FileExists('.\gestapo\SurveillanceUnits\'+FileName) then begin
  IniFile.WriteString(DeviceName+'Limits'+IntToStr(row),'priority',Prioritydata.Strings[0]);
  IniFile.WriteString(DeviceName+'Limits'+IntToStr(row),'Start',Prioritydata.Strings[1]);
  IniFile.WriteString(DeviceName+'Limits'+IntToStr(row),'End',Prioritydata.Strings[2]);
  IniFile.WriteString(DeviceName+'Limits'+IntToStr(row),'Min',Prioritydata.Strings[3]);
  IniFile.WriteString(DeviceName+'Limits'+IntToStr(row),'Max',Prioritydata.Strings[4]);
  IniFile.WriteString(SearchDevice(FileName,DeviceName),'AlarmModes',PriorityData.Strings[5])
  end
  else exception.Create('File ('+FileName+') dont exists');

end;

procedure TGUIControl.WriteDeviceData(const FileName: String; const DeviceName: String;
                                      const Data: TStrings);
var i: Integer;
begin
  IniFile:=TIniFile.Create('.\gestapo\config\'+FileName+'.ini');
  IniFile.WriteString(SearchDevice(FileName+'.ini',DeviceName),'AlarmModes',Data.Strings[data.count-1]);
  Data.Delete(data.count-1);
  for i:=0 to (Data.Count div 5)-1 do
  begin
  IniFile.WriteString(DeviceName+'Limits'+IntToStr(i),'priority',Data.strings[0]);
  IniFile.WriteString(DeviceName+'limits'+IntToStr(i),'Starttime',Data.Strings[1]);
  IniFile.WriteString(deviceName+'limits'+IntToStr(i),'endtime', Data.Strings[2]);
  IniFile.WriteString(DeviceName+'limits'+IntToStr(i),'minlimit', Data.Strings[3]);
  IniFile.WriteString(DeviceName+'limits'+IntToStr(i),'maxlimit',Data.Strings[4]);
  end;
  //SendFile(FileName);
end;

function TGUIControl.SearchDeviceTypes(const FileName: String): TStrings;
var FileIni: TIniFile;
    DeviceTypes: TStrings;
    i: Integer;
    count: Integer;
begin
   DeviceTypes:=TStringList.Create;
   FileIni:=TIniFile.Create(FileName);
   count:=GetCount(FileName);
   for i:=0 to count-1 do
   begin
     if Fileini.ReadString('device'+IntToStr(i),'Type','0')='Camera' then continue
     else DeviceTypes.Add(FileIni.ReadString('device'+IntToStr(i),'Type','0'));
   end;
   result:=DeviceTypes;
end;

function TGUIControl.SearchDevicesToRealTimeValues(const FileName: String): TStrings;
var FileIni: TIniFile;
    Devicenames: TStrings;
    i: Integer;
begin
   DeviceNames:=TstringList.Create;
   FileIni:=TIniFile.Create(FileName);
   for i:=0 to GetCount(FileName)-1 do
   begin
   if FileIni.ReadString('device'+IntToStr(i),'Type','0')='Camera' then continue
   else DeviceNames.Add(FileIni.ReadString('device'+IntToStr(i),'DeviceName','0'));
   end;
   result:=devicenames;
end;

procedure TGUIControl.WritePriority(const PriorityData: TStrings;
                                    const NumberOfPriorities: String; const sectionindex: Integer);

begin
   if FileExists('.\gestapo\config\alarmunit.ini') then
   begin
   IniFile:=TIniFile.Create('.\gestapo\config\alarmunit.ini');
   IniFile.WriteString('general','NumberOfPriorities',NumberOfPriorities);

   IniFile.WriteString('Priority'+IntToStr(sectionindex),'priorityvalue',PriorityData.Strings[0]);
   IniFile.WriteString('Priority'+IntToStr(sectionindex),'UseSMS',PriorityData.Strings[1]);
   IniFile.WriteString('Priority'+IntToStr(sectionindex),'UseEmail',Prioritydata.Strings[2]);
   IniFile.WriteString('Priority'+IntToStr(sectionindex),'UseLocalDevice',PriorityData.Strings[3]);
   IniFile.WriteString('Priority'+IntToStr(sectionindex),'RepeatInterval',PriorityData.Strings[4]);
   IniFile.WriteString('Priority'+IntToStr(sectionindex),'Target',PriorityData.Strings[5]);
   end
   else Exception.Create('File dont exist');
   IniFile.Free;
end;


procedure TGUIControl.GetAllDeviceLogFiles(const unitname: String);
begin

end;



procedure TGUIControl.DeleteAllFiles(const path: String);
var FileNames: TStrings;
    i: Integer;
begin
  FileNames:=TStringList.Create;
  FileNames:=ReadIniFileNames;
  for i:=0 to Filenames.Count-1 do
    DeleteFile(path+Filenames[i]);
  DeleteFile(path+'AlarmUnit.ini');
  SurveillanceUnitCount:=0;
end;

function TGUIControl.ReadCommunicationSettingsIniFile(): TStrings;
var Communicationsdata: TStrings;
begin
  Communicationsdata:=TStringList.Create();
  result:=communicationsdata;
  if FileExists('.\gestapo\communications.ini') then
  begin
    IniFile:=TIniFile.Create('.\gestapo\communications.ini');
    Communicationsdata.Add(IniFile.ReadString('Settings','IP','0,0,0,0'));
    Communicationsdata.Add(IniFile.ReadString('Settings','Port','0'));
  end
  else exception.Create('file not found!');
  IniFile.Free;
end;

function TGUIControl.SearchDeviceType(const FileName,
  deviceName: String): String;
var devicetype: String;
    device: String;
begin
   IniFile:=TIniFile.Create('.\gestapo\config\'+FileName);
   device:= SearchDevice(FileName,DeviceName);
  devicetype:=IniFile.ReadString(SearchDevice(FileName,DeviceName),'Type','');
   result:= devicetype;
end;


function TGUIControl.SensorValue(const FileName: String): String;
var F1: TextFile;
    line: String;
begin
    if FileExists(FileName) then begin
    AssignFile(F1,FileName);
    Reset(F1);
    while not eof(F1) do
    begin
       ReadLn(F1,line);
    end
   end
   else exception.Create('File not found');
   result:=parseString(line,' ',1);

end;

function TGUIControl.SearchLatestAlarms: TStrings;
var F1: TextFile;
    AllAlarms: TStrings;
    Alarms: TStrings;
    line: String;
begin
    AllAlarms:=TStringList.Create;
    Alarms:=TStringList.Create;
    AssignFile(F1,'.\gestapo\log\alarmunit\alarm.dat');
    Reset(F1);
    while not eof(F1) do
    begin
      ReadLn(F1,line);
      AllAlarms.Add(line);
    end;
    Alarms.Add(AllAlarms.Strings[AllAlarms.Count-1]);//last
    Alarms.Add(AllAlarms.Strings[AllAlarms.Count-2]);
    Alarms.Add(AllAlarms.Strings[AllAlarms.Count-3]);
    Alarms.Add(AllAlarms.Strings[AllAlarms.Count-4]);
    Alarms.Add(AllAlarms.Strings[AllAlarms.Count-5]);
    AllAlarms.Destroy;
    result:=Alarms;
end;

function TGUIControl.AllRealTimeSensorValues(
  const IniFileName: String): TStrings;
var SensorValues: TStrings;
    Sensors: TStrings;
    sensortypes: TStrings;
    i: Integer;
begin
  SensorValues:=TStringList.Create;
  Sensors:=TStringList.Create;
  sensortypes:=TStringlist.Create;
  Sensors:=SearchDevicesToRealTimeValues(IniFileName);
  sensortypes:=SearchDeviceTypes(IniFileName);
  for i:=0 to Sensors.Count-1 do
  begin
    SensorValues.Add(Sensorvalue('.\gestapo\log\'+sensortypes.Strings[i]+'_'+Sensors.Strings[i]+'.dat'));
  end;
  result:=SensorValues;
end;

function TGUIControl.ReadDatesFromLog(const FileName: String): TStrings;
var F1: TextFile;
    line: String;
    Dates: TStrings;
begin
   Dates:=TStringList.Create;
   AssignFile(F1,FileName);
    Reset(F1);
    while not eof(F1) do
    begin
      ReadLn(F1,line);
      if StringExists(EraseDate(line),Dates) then continue
      else Dates.Add(EraseDate(line));
    end;
    result:=Dates;
end;

function TGUIControl.EraseDate(line: String): String;
begin
  result:=parsestring(line);
end;

function TGUIControl.StringExists(line: String;
  Strings: TStrings): Boolean;
var i: Integer;
begin
    result:=false;
    for i:=0 to Strings.Count-1 do
        if Strings.Strings[i]=line then result:=true
end;

function TGUIControl.GetTimesFromTemperatureLog(const date: String; const FileName: String): TStrings;
var F1: TextFile;
    line: String;
    temperaturedata: TStrings;
begin
  temperaturedata:=TStringList.Create;
  result:=temperaturedata;
  AssignFile(F1,FileName);
  Reset(F1);
  while not eof(F1) do
  begin
    ReadLn(F1,line);
    if StrToDate(date)<StrToDate(Erasedate(line)) then exit;
    if StrToDate(date)>StrToDate(EraseDate(line)) then continue;
    if StrToDate(date)=StrToDate(EraseDate(line)) then temperaturedata.Add(line);
    end;
end;
{ To Erase temperature measurement time EraseDate is used twice}
function TGUIControl.CalculateTheAverageTemperaturePerHour(): TStrings;
var temperatures: TStrings;
begin
   temperatures:=TStringList.create;
   temperatures.add('24');
   temperatures.Add('24');
   temperatures.Add('25');
   result:=temperatures;
end;

function TGUIControl.GetFileNames(const path: String): TStrings;
var   FoundFile: TSearchRec;
      FileAttr: Integer;
      FileNames: TStrings;
      FileName: String;
begin
  FileNames:=TStringList.Create;
  FileAttr:=faAnyFile;
  FindFirst(path+'*',FileAttr,FoundFile);
  FindNext(FoundFile);
  while FindNext(FoundFile)=0 do
   begin
   FileName:=FoundFile.Name;
   If FileName='alarmunit.ini' then continue;//used only when reading Ini-files
   FileNames.Add(FoundFile.Name);
   SurveillanceUnitCount:=SurveillanceUnitCount+1;
   end;
   result:=FileNames
end;

end.
