unit GestapoMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, QComCtrls, ExtCtrls,Menus,
  IniFiles, ComCtrls,GUIControl, DBCtrls, jpeg,
  TeeProcs, TeEngine, Chart, Communicationsettings, HelpTools, Series,
  CommunicationClient ;

type
  TForm1 = class(TForm)
    TreeView1: TTreeView;
    StringGridLatestAlarms: TStringGrid;
    Label1: TLabel;
    ButtonClearLatestAlarms: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    CommunicationSettings1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    About2: TMenuItem;
    Timer1: TTimer;
    Timer2: TTimer;
    Timer3: TTimer;
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    TabSheet4: TTabSheet;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Label15: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label11: TLabel;
    DBNavigator1: TDBNavigator;
    Chart1: TChart;
    TabSheet5: TTabSheet;
    TabSheet1: TTabSheet;
    LabelRealTimeUnitName: TLabel;
    Label22: TLabel;
    Button5: TButton;
    StringGridRealTimeValues: TStringGrid;
    Timer4: TTimer;
    Series1: TFastLineSeries;
    Button1: TButton;
    ComboBoxTemperatureChart: TComboBox;
    GroupBox1: TGroupBox;
    ButtonAddPriority: TButton;
    ButtonRemovePriority: TButton;
    StringGridPriorities: TStringGrid;
    Label28: TLabel;
    Label29: TLabel;
    ButtonAlarmUnitConfSave: TButton;
    ButtonAlarmUntiConfCancel: TButton;
    StringGridAlarmTarget: TStringGrid;
    Button2: TButton;
    Button6: TButton;
    GroupBox2: TGroupBox;
    Label10: TLabel;
    ComboBoxSurveillanceUnits: TComboBox;
    Label9: TLabel;
    ComboBoxDevices: TComboBox;
    Button4: TButton;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    EditDeviceCaptureInterval: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    LabelDeviceType: TLabel;
    LabelDeviceSettingsDeviceName: TLabel;
    LabelDeviceSettingsUnitName: TLabel;
    Button3: TButton;
    ButtonSaveDeviceSettings: TButton;
    StringGridDeviceAlarmLimits: TStringGrid;
    StatusBar1: TStatusBar;
    GroupBox4: TGroupBox;
    Image7: TImage;
    LabelImage3: TLabel;
    Image8: TImage;
    LabelImage4: TLabel;
    LabelImage2: TLabel;
    LabelImage1: TLabel;
    Image5: TImage;
    Image6: TImage;
    GroupBoxHideDeviceSettings: TGroupBox;
    MemoDeviceSettings: TMemo;
    ButtonAddLimit: TButton;
    Button8: TButton;

    procedure CommunicationSettings1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    function  CountSubItems(Node: Integer): Integer;
    procedure PutValuesToStringGridTarget(TargetStringGrid: TStringGrid; data: TStrings; index: Integer);
    procedure ShowAlarmTargets();
    procedure DeviceAlarmLimits();
    procedure ShowPriorities();
    function  IntegerToBooleanString(i: Integer): string;
    procedure FormCreate(Sender: TObject);
    procedure CreateTree(FileName: TStrings);
    procedure ChangeDeviceDatasToDeviceSettings(selectedNode: TTreeNode);
    function  GetSubNodeNames(const FileName: String): TStrings;
    procedure PutAlarmLimitToStringGrid(const AlarmLimits: TStrings);
    procedure ClearStringGrid(grid: TStringGrid);
    function  GetValuesFromStringGrid(grid: TStringGrid; row: Integer): TStrings;
    procedure ButtonAlarmUnitConfSaveClick(Sender: TObject);
    procedure ButtonAlarmUntiConfCancelClick(Sender: TObject);
    procedure ButtonSaveDeviceSettingsClick(Sender: TObject);
    procedure HideAlarmLimitsStringGrid();
    procedure ShowAlarmLimitsStringGrid();
    procedure PutDevicesToComboBox();
    procedure ComboBoxSurveillanceUnitsSelect(Sender: TObject);
    procedure RealTimeValues(const FileName: String);
    procedure PaintFixedRows(grid: TStringGrid);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure GetdeviceDataFromIni(const FileName: String; const DeviceName: String);
    procedure ClearStringList(Strings: TStrings);
    procedure SearchLatestAlarms();
    procedure ButtonClearLatestAlarmsClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboBoxTemperatureChartChange(Sender: TObject);
    procedure DrawChart(const SelectedDay: TCaption);
    procedure ConnectToDataUnit();
    procedure CloseConnection();
    procedure sendFile(const FileName: String);
    procedure GetFiles(const command: String; const resultpath: String);
    procedure GetAllIniFiles;
    procedure GetSensorDatas(const sensorname: String; const unitname: String);
    procedure ProcessCommand(Sender: TObject; Text: String);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure ButtonAddPriorityClick(Sender: TObject);
    procedure ShowLatestPictures(unitname: String);
    procedure HidePictures(numberofpicturestohide: Integer);
    procedure ShowAllPictures(const value: Boolean);
    procedure PageControlAlarmMode();
    procedure PageControlSurveillanceUnitMode;
    procedure Button2Click(Sender: TObject);
    procedure ButtonAddLimitClick(Sender: TObject);
  private
    GUICtrl: TGUIControl;
    SelectedDevice: TStrings;
    Devices: Tstrings; //jrjestelmn laitteiden nimet
    DeviceData: TStrings;//laitteen tiedot, GetdeviceDatafromIni()
    DeviceTypes: TStrings;//getDeviceDataFromIni();
    UnitNames: TStrings; //CreateTree();
    alarmdata: TStrings;
    targets: TStrings;// readalarmtargetini(i)
    alarmlimits: TStrings;
     Client: TCommunicationClient;
    { Private declarations }

  public
    { Public declarations }
  end;

var
  Form1: TForm1;


implementation

uses About;

{$R *.dfm}

procedure TForm1.CommunicationSettings1Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  //GUICtrl.CloseConnection;
  close;
end;

procedure TForm1.About2Click(Sender: TObject);
begin
  FormAbout.Show;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
  var paivays: TDateTime;
  var clocktime: TDateTime;
  var jono: String;
  var clock: String;
  var dateandtime: String;
begin
  paivays:=Date;
  jono:=DateTimeToStr(paivays);
  clocktime:=Time;
  clock:=TimeToStr(clocktime);
  dateandtime:=jono + ' ' +clock;
  StatusBar1.SimpleText:=dateandtime;
end;
{laskee solmun alisolmujen lukumrn}
function TForm1.CountSubItems(node: Integer): Integer;
var SubItems: Integer;
begin
  SubItems:=Treeview1.Items.Item[node].GetLastChild.Index;
  result:=SubItems+1;
end;

procedure TForm1.DeviceAlarmLimits();
begin
   StringGridDeviceAlarmLimits.Cells[0,0]:='Priority';
   StringGridDeviceAlarmLimits.Cells[1,0]:='Start Time';
   StringGridDeviceAlarmLimits.Cells[2,0]:='End Time';
   StringGridDeviceAlarmLimits.Cells[3,0]:='Min. Limit';
   StringGridDeviceAlarmLimits.Cells[4,0]:='Max. Limit';
end;

procedure TForm1.PutValuesToStringGridTarget(TargetStringGrid: TStringGrid;
                                             data: TStrings; index: Integer);
var i: Integer;
begin
   TargetStringGrid.RowCount:=targetStringGrid.RowCount+1;
   for i:=0 to data.Count-1 do
    begin

     TargetStringGrid.Cells[i,index+1]:=data[i];
    end;
   PaintFixedRows(TargetStringGrid);
end;

procedure TForm1.ShowAlarmTargets();
var
    i: Integer;
begin
   targets:=TStringlist.Create();
   StringGridAlarmTarget.Cells[0,0]:='Target Number';
   StringGridAlarmTarget.Cells[1,0]:='Name';
   StringGridAlarmTarget.Cells[2,0]:='Email Address';
   StringGridAlarmTarget.Cells[3,0]:='GSM Number';
   for i:=0 to GUICtrl.GetCount('.\gestapo\config\alarmunit.ini')-1 do
   begin
     targets:=GUICtrl.ReadAlarmTargetIni(i);
     PutValuesToStringGridTarget(StringGridAlarmTarget,targets,i);
   end;
  // alarmdata.Destroy();
end;

function TForm1.IntegerToBooleanString(i: Integer): String;
begin
  if i=0 then result:='false'
  else result:='true';
end;

procedure TForm1.ShowPriorities();
var prioritydata: TStrings;
    prioritycount: Integer;
    i: Integer;
begin
  prioritydata:=TStringList.Create;
  prioritycount:=GUICtrl.GetCount('.\gestapo\config\alarmunit.ini','NumberOfPriorities');
  StringGridPriorities.Cells[0,0]:='Priority';
  StringGridPriorities.Cells[1,0]:='Email';
  StringGridPriorities.Cells[2,0]:='GSM';
  StringGridPriorities.Cells[3,0]:='Local device';
  StringGridPriorities.Cells[4,0]:='Repeat Interval';
  StringGridPriorities.Cells[5,0]:='Target';

  for i:=0 to prioritycount-1 do
   begin
   prioritydata:=GUICtrl.ReadPrioritiesIni(i);
   PutValuesToStringGridTarget(StringGridPriorities,prioritydata,i);
   end;
end;

procedure TForm1.CreateTree(FileName: TStrings);
var i,j: Integer;
    filenam: String;
    nodenames: TStrings;
    Node: Ttreenode;

begin
  UnitNames:=TStringList.Create;
  nodenames:=TStringList.Create;
  Node:= Ttreenode.Create(Treeview1.Items);
  for i:=0 to GUICtrl.SurveillanceUnitCount-1 do
  begin
    filenam:=FileName.Strings[i];
    Node:=Treeview1.Items.Add(Treeview1.Items.GetFirstNode,GUICTrl.RemoveIniFromFileName(FileNam));
    nodenames:=GetSubNodeNames(filenam);
    UnitNames.Add(Node.text);
  for j:=0 to nodenames.Count-1 do
  begin
  Treeview1.Items.AddChild(Node,nodenames.Strings[j]);
  end;
  end;
  Treeview1.Items.Add(Treeview1.Items.GetFirstNode,'Alarm Unit');
  ComboBoxSurveillanceUnits.Items:=UnitNames;
  ComboBoxSurveillanceUnits.Text:=ComboBoxSurveillanceUnits.Items.Names[0];
  ShowPriorities();
  ShowAlarmTargets();
  deviceAlarmLimits();
end;

function TForm1.GetSubNodeNames(const FileName: String): TStrings;
var devicedata: TStrings;
    devicenames: TStrings;
    i: Integer;
begin
  devicedata:=TStringList.Create;
  devicenames:=TStringList.Create;
  i:=1;
  devicedata:=GUICtrl.ReadDeviceDataFromIni(FileName);
  while i<devicedata.Count do
  begin
  devicenames.Add(devicedata.Strings[i]);
  i:=i+5;
  end;
  result:=devicenames;
end;

procedure TForm1.ChangeDeviceDatasToDeviceSettings(selectedNode: TTreenode);
begin

    LabelDeviceSettingsDeviceName.Caption:=SelectedNode.Text;
    LabelDeviceSettingsUnitName.Caption:=SelectedNode.Parent.Text;
    DeviceData:=GUICtrl.ReadOneDevicesDataFromIni(SelectedNode.Parent.Text+ '.ini', selectedNode.text);
    LabelDeviceType.Caption:=DeviceData.Strings[2];

    EditDeviceCaptureInterval.Text := DeviceData.Strings[4];
    if DeviceData.Strings[2]='Camera' then
    begin
    HideAlarmlimitsStringGrid(); exit;
    end
    else begin
    ShowAlarmLimitsStringGrid();
    alarmlimits:=GUICTrl.ReadAlarmLimitsFromIniFile(SelectedNode.Parent.Text+ '.ini',SelectedNode.Text);
    PutAlarmLimitToStringGrid(AlarmLimits);
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   SelectedDevice:=TStringList.Create;
   SelectedDevice.Add('');
   SelectedDevice.Add('');
   Tabsheet5.Tabvisible:=false;
   GUICtrl:=TGUIControl.Create(self);
   Timer2.Enabled:=true;
   Timer3.Enabled:=true;
   SearchLatestAlarms;
  { Client:=TCommunicationClient.Create(self);
   ConnectToDataUnit();}
end;

procedure TForm1.ClearStringGrid(grid: TStringGrid);
begin
  grid.RowCount:=1;
end;

procedure TForm1.PutAlarmLimitToStringGrid(const AlarmLimits: TStrings);
var i: Integer;
    j: Integer;
begin
  ClearStringGrid(StringGridDeviceAlarmLimits);
  j:=0;
  for i:=0 to (AlarmLimits.Count div 5)-1 do
  begin
  StringGridDeviceAlarmLimits.RowCount:=StringGridDeviceAlarmLimits.RowCount+1;
  StringGridDeviceAlarmLimits.Cells[0,i+1]:=AlarmLimits.Strings[j];
  StringGridDeviceAlarmLimits.Cells[1,i+1]:=AlarmLimits.Strings[j+1];
  StringGridDeviceAlarmLimits.Cells[2,i+1]:=AlarmLimits.Strings[j+2];
  StringGridDeviceAlarmLimits.Cells[3,i+1]:=AlarmLimits.Strings[j+3];
  StringGridDeviceAlarmLimits.Cells[4,i+1]:=AlarmLimits.Strings[j+4];
  j:=j+5
  end;
  PaintFixedRows(StringGridDeviceAlarmLimits);
end;

function TForm1.GetValuesFromStringGrid(grid: TStringGrid; row: Integer): TStrings;
var StringGridValues: TStrings;
    i: Integer;
    data: string;

begin
    StringGridValues:=TStringList.Create;
    for i:=0 to grid.ColCount-1 do  begin
      data:=grid.cells[i,row];
      StringGridValues.Add(grid.Cells[i,row]);
    end;
  result:=StringGridValues;
end;

procedure TForm1.ButtonAlarmUnitConfSaveClick(Sender: TObject);
var i: Integer;
begin
   for i:=1 to StringGridAlarmTarget.RowCount-1 do
   GUICtrl.WriteAlarmTargetIni(GetValuesFromStringGrid(StringGridAlarmTarget,i),IntToStr(StringGridAlarmTarget.RowCount-1),i);

   for i:=1 to StringGridPriorities.RowCount-1 do
   GUICtrl.WritePriority(GetValuesFromStringGrid(StringGridPriorities,i),IntToStr(StringGridPriorities.RowCount-1),i-1);

  // GUICtrl.sendFile('alarmunit.ini');
end;

procedure TForm1.ButtonAlarmUntiConfCancelClick(Sender: TObject);
begin
  ClearStringGrid(StringGridAlarmtarget);
  ShowAlarmtargets();
  ClearStringGrid(StringGridpriorities);
  ShowPriorities();
end;

procedure TForm1.ButtonSaveDeviceSettingsClick(Sender: TObject);
var i: Integer;
    data: TStrings;
begin
   data:=TStringList.Create;
   for i:=0 to StringGridDeviceAlarmLimits.RowCount do
   begin
     data:=GetValuesFromStringGrid(StringGridDeviceAlarmLimits,i);
     data.Add(EditDeviceCaptureInterval.text);
     if data.Strings[0]='' then exit;
     GUICtrl.WriteDeviceData(LabelDeviceSettingsUnitName.Caption,LabelDeviceSettingsDeviceName.Caption,data)
   end;
end;

procedure TForm1.HideAlarmLimitsStringGrid;
begin
  StringGridDeviceAlarmLimits.Visible:=false;
  ButtonSaveDeviceSettings.Visible:=false;
  Button3.Visible:=false;
  Label8.Visible:=false;

end;

procedure TForm1.ShowAlarmLimitsStringGrid;
begin
  StringGridDeviceAlarmLimits.Visible:=true;
  Label8.Visible:=true;
  ButtonSaveDeviceSettings.Visible:=true;
  Button3.Visible:=true;
end;

procedure TForm1.PutDevicesToComboBox();
begin
   ComboBoxDevices.Items:=GetSubNodenames(ComboBoxSurveillanceUnits.Text+'.ini');
   ComboBoxDevices.Text:=ComboBoxDevices.Items.Names[0];
end;

procedure TForm1.ComboBoxSurveillanceUnitsSelect(Sender: TObject);
begin
  PutDevicesToComboBox();
end;

procedure TForm1.RealTimeValues(const FileName: String);
var
    i: Integer;
    sensorvalues: TStrings;

begin

  Devices:=TStringList.Create;
  sensorvalues:=TStringList.Create;
  ClearStringGrid(StringGridRealTimeValues);
  StringGridRealTimevalues.Cells[0,0]:='SensorType';
  StringGridRealTimeValues.Cells[1,0]:='Sensor';
  StringGridRealTimeValues.Cells[2,0]:='Value';
  Devices:=GUICtrl.SearchDevicesToRealTimeValues(FileName);
  devicetypes:=GUICtrl.SearchDeviceTypes(Filename);
  sensorvalues:=GUICtrl.AllRealTimeSensorValues(filename);
  for i:=0 to Devices.Count-1 do  begin
   StringGridRealTimeValues.RowCount:=StringGridRealTimeValues.RowCount+1;
   StringGridRealTimeValues.Cells[1,i+1]:=Devices.Strings[i];
   end;
  for i:=0 to devicetypes.Count-1 do
   StringGridRealTimeValues.Cells[0,i+1]:=DeviceTypes.Strings[i];
  for i:=0 to StringGridrealTimeValues.RowCount-2 do
   StringGridRealTimeValues.Cells[2,i+1]:=sensorvalues.Strings[i];

  PaintFixedRows(StringGridRealTimeValues);
end;

procedure TForm1.PaintFixedRows(grid: TStringGrid);
begin
  if grid.rowcount>1 then grid.FixedRows:=1;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
   Timer2.Enabled:=false;
  // GUICtrl.GetAllIniFiles;
end;

procedure TForm1.Timer3Timer(Sender: TObject);
begin
   Timer3.Enabled:=false;
   CreateTree(GUICtrl.ReadIniFileNames);
end;

procedure TForm1.GetdeviceDataFromIni(const FileName: String; const DeviceName: String);
begin
 DeviceData:=GUICtrl.ReadOneDevicesDataFromIni(FileName+'.ini',DeviceName);
 DeviceTypes:=GUICtrl.SearchDeviceTypes(FileName);
end;

procedure TForm1.ClearStringList(Strings: TStrings);
var i: Integer;
begin
  for i:=Strings.Count-1 downto 0 do
    Strings.Delete(i);
end;
{GUI.SearchLatestalarms searches 5 latest. This procedure
 cuts information from StringLists and PutValuesToStringGridTarget-procedure
 sets information to StringGrid}
procedure TForm1.SearchLatestAlarms;
var i: Integer;
    alarms: TStrings;
    Alarm: TStrings;
    line: String;
    line2: String;
begin
    Alarm:=TStringList.Create;
    alarms:=TStringList.Create;
    alarms:=GUICtrl.SearchLatestAlarms;

    for i:=0 to alarms.Count-1 do
    begin
       line2:=alarms.Strings[i];
       line:=ParseString(line2); //remove text 'received'
       alarm.Add(ParseString(line2));//add date
       alarm.Add(ParseString(line2));//add time
       alarm.Add(parsestring(line2));//add unit name
       alarm.Add(parsestring(line2));//add device name
       parsestring(line2);//remove unneccessary
       alarm.Add(parsestring(line2));//priority
       PutValuesToStringGridTarget(StringGridLatestAlarms,alarm,i);
       ClearStringList(alarm);
    end;
    StringGridLatestAlarms.Cells[0,0]:='Date';
    StringGridLatestAlarms.Cells[1,0]:='Time';
    StringGridLatestAlarms.Cells[2,0]:='Unit Name';
    StringGridLatestAlarms.Cells[3,0]:='Device Name';
    StringGridLatestAlarms.Cells[4,0]:='Priority';
end;

procedure TForm1.ButtonClearLatestAlarmsClick(Sender: TObject);
begin
  ClearStringGrid(StringGridLatestAlarms);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    ComboboxTemperatureChart.Items:=GUICtrl.ReadDatesFromLog('.\gestapo\log\C225_3_2\Temperature_Sensor_joy1x.dat');
    Drawchart(ComboboxTemperaturechart.Text);
end;

procedure TForm1.ComboBoxTemperatureChartChange(Sender: TObject);
begin
   DrawChart(ComboboxTemperatureChart.Text);
end;

procedure TForm1.DrawChart(const SelectedDay: TCaption);
var temperaturedata: TStrings;
    i: integer;
begin
  temperaturedata:=TStringList.Create;
  temperaturedata:=GUICtrl.CalculateTheAverageTemperaturePerHour();
  for i:=0 to temperaturedata.Count-1 do
    Series1.Add(StrToInt(temperaturedata[i]));
end;

procedure TForm1.ConnectToDataUnit();
var comsettings: TStrings;
begin
   comsettings:=TStringList.Create;
   comsettings:=GUICtrl.ReadCommunicationSettingsiniFile();
   Client:=TCommunicationClient.create(self);
   client.HostIP:='127.0.0.1';//comsettings.Strings[0];
   client.Name:='ConfigurationUnit';
   client.Port:=10079;//StrToint(comsettings.Strings[1]);
   client.OnReadText:=processcommand;
   client.Start;
end;

procedure TForm1.CloseConnection;
begin
  client.Free;
end;

procedure TForm1.sendFile(const FileName: String);
begin
  client.SendFile('.\gestapo\config\'+FileName,'.\config\'+FileName);
end;

procedure TForm1.GetFiles(const command: String; const resultpath: String);
begin
  client.SendText(command+' '+resultpath);
end;

procedure TForm1.GetSensorDatas(const sensorname: String; const unitname: String);
var SensorDatas: TStrings;
begin
  SensorDatas:=TStringList.Create();
  client.GetFile('.\'+unitname+'\'+sensorname+'.dat','.\gestapo\log\');
end;

procedure TForm1.ProcessCommand(Sender: TObject; Text: String);
var command: String;//ksky
    SU_name: String;
    path: String;
begin               //TEKSTISS TIEDOSTON NIMI
  command:=parsestring(text,' ',0);
  if command='' then command:=text;
  if command='CU_TAKEFILE' then {hae kuva ja pistruutuun}
     begin
       SU_Name:=parsestring(text,' ',0);
       path:=text;
       client.GetFile(path,'.\gestapo\log\'+SU_name+'\camera0.bmp');
       {pist kuva ruutuun}
     end;
end;

procedure TForm1.GetAllIniFiles;
begin
  client.SendText('DU_READCONFIGS .\gestapo\config\');
end;

procedure TForm1.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
   if Treeview1.Selected.Parent.Index=-1 then
    begin
       if Treeview1.Selected.Text='Alarm Unit' then
          begin
             PageControlAlarmMode();
             Exit;
          end;
      GroupBoxHideDeviceSettings.Visible:=true;
      PageControlSurveillanceUnitMode();
      LabelRealTimeUnitName.Caption:=Treeview1.Selected.Text;
      RealTimeValues('.\gestapo\config\'+Treeview1.Selected.Text+'.ini');
      exit;
    end;
    PageControlSurveillanceUnitMode();
    GroupBoxHideDeviceSettings.Visible:=false;
    ChangeDeviceDatasToDeviceSettings(Treeview1.Selected);

    SelectedDevice.Strings[0]:=Treeview1.Selected.Text; //valittu solmu
    SelectedDevice.Strings[1]:=Treeview1.Selected.Parent.Text; //vamhempi solmu
    //ClearStringList(DeviceData);
    //ClearStringList(AlarmLimits);
    GetDeviceDataFromIni(Treeview1.Selected.Parent.Text,Treeview1.Selected.Text);
   // GUICtrl.GetAllDeviceLogFiles(Treeview1.Selected.Parent.text,
    //                            GetSubNodeNames(Treeview1.Selected.Parent.text+'.ini'));
    ChangeDeviceDatasToDeviceSettings(Treeview1.Selected);
   if Treeview1.Selected.Parent=nil then exit;
   end;

procedure TForm1.ButtonAddPriorityClick(Sender: TObject);
begin
  StringGridPriorities.RowCount:=StringGridPriorities.RowCount+1;
end;

procedure TForm1.HidePictures(numberofpicturestohide: Integer);
begin
  if numberofpicturestohide=4 then
     GroupBox4.Visible:=false;
  if numberofpicturestohide=3 then
     begin
         GroupBox4.Visible:=true;
         Image1.Visible:=true;
     end;
  if numberofpicturestohide=2 then
     begin
         GroupBox4.Visible:=true;
         Image1.Visible:=true;
         Image2.Visible:=true;
     end;
  if numberofpicturestohide=1 then
     begin
         GroupBox4.Visible:=true;
         Image1.Visible:=true;
         Image2.Visible:=true;
         Image3.Visible:=true;
     end;
end;

procedure TForm1.ShowLatestPictures(unitname: String);
var FileNames: TStrings;
    i: Integer;
begin
  {Pyyd uudet kuvat, pistetn kansioon realtime}
   FileNames:=TStringList.Create;
   FileNames:=GUICtrl.GetFileNames('.\gestapo\realtime\');
   case Filenames.Count of
   0:  HidePictures(4);
   1:  HidePictures(3);
   2:  HidePictures(2);
   3:  HidePictures (1);
   4:  ShowAllPictures(true);
   end;
end;

procedure TForm1.ShowAllPictures(const value: Boolean);
begin
  Image1.Visible:=value;
  Image2.Visible:=value;
  Image3.Visible:=value;
  Image4.Visible:=value;
end;

procedure TForm1.PageControlAlarmMode;
begin
   Tabsheet1.TabVisible:=false;
   Tabsheet2.TabVisible:=false;
   tabsheet4.TabVisible:=false;
   tabsheet5.TabVisible:=true;
end;

procedure TForm1.PageControlSurveillanceUnitMode;
begin
   Tabsheet1.TabVisible:=true;
   Tabsheet2.TabVisible:=true;
   tabsheet4.TabVisible:=true;
   tabsheet5.TabVisible:=false;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   StringGridAlarmTarget.RowCount:=StringGridAlarmTarget.RowCount+1;
end;

procedure TForm1.ButtonAddLimitClick(Sender: TObject);
begin
  StringGridDeviceAlarmLimits.RowCount:= StringGridDeviceAlarmLimits.RowCount+1;
end;

end.
